namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Synchronize is an ability that passes major status conditions to the foe that inflicted them.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Synchronize_(Ability)">Bulbapedia - Synchronize</see>
/// </summary>
[Script(ScriptCategory.Ability, "synchronize")]
public class Synchronize : Script, IScriptOnAfterStatusChange
{
    /// <inheritdoc />
    public void OnAfterStatusChange(IPokemon pokemon, StringKey status, IPokemon? originPokemon)
    {
        if (originPokemon == null || pokemon == originPokemon)
            return;
        pokemon.BattleData?.Battle.EventHook.Invoke(new AbilityTriggerEvent(pokemon));
        originPokemon.SetStatus(status, pokemon);
    }
}